@echo off
if "%1" == "/?" goto help
set reverse=0
set filename =
set description =
set compile_to =
if not exist %1.hal goto errors
set filename=%1
shift

if "%1" == "/r" set reverse = 1
if "%1" == "/r" shift

if "%1" == "/ash" set compile_to=ash
if "%1" == "/oshell" set compile_to=oshell
if "%1" == "/zshell" set compile_to=zshell
if "%1" == "/83" set compile_to=83
if "%1" == "/86" set compile_to=86
shift

if "%1" == "/r" set reverse = 1
if "%1" == "/r" shift

set description=%1 %2 %3 %4 %5 %6 %7 %8 %9
if "%description%" == "         " set description=HAL program
if "%compile_to%" == "" goto errors
if "%compile_to%" == "ash" goto comp_ash
if "%compile_to%" == "oshell" goto comp_oshell
if "%compile_to%" == "zshell" goto comp_zshell
if "%compile_to%" == "83" goto comp_83
if "%compile_to%" == "86" goto comp_86
goto errors

:help
echo HAL - Higher Assembly Language
echo c.2021 Eggplant Farms
echo.
echo Usage:
echo HAL filename /{ash/oshell/83/zshell/86} [/r] [description]
echo.
echo Filename should have NO extention, it is assumed to be .hal
echo /r parameter reverses case, IE. HAL commands are assumed to
echo to be in upper case.
echo.
echo For help, questions, or comments, please write to EggplFarms@aol.com
goto done

:comp_ash
echo compiling to Ash
hal82as %filename% %reverse% %description%
tasm.exe -80 -b -r16 %filename%.asm
if errorlevel 1 goto errors
prgm82.exe %filename%
if errorlevel 1 goto errors
goto done

:comp_oshell
pause
echo compiling to OShell
pause
hal82os %filename% %reverse% %description%
pause
tasm.exe -80 -c -g3 -Q %filename%.asm
if errorlevel 1 goto errors
oshell82 %filename%
if errorlevel 1 goto errors
fix %filename%.82p
if errorlevel 1 goto errors
goto done

:comp_83
echo compiling to TI83-OS
hal83 %filename% %reverse% %description%
tasm.exe -80 -o20 -p60 -q -i %filename%.asm
if errorlevel 1 goto errors
prep83.exe %filename%
if errorlevel 1 goto errors
goto done

:comp_zshell
echo compiling to ZShell
hal85 %filename% %reverse% %description%
tasm.exe -80 -g3 -r8 -q -i %filename%.asm
ren %filename%.obj %filename%
if errorlevel 1 goto errors
string85.com %filename%
del %filename%
if errorlevel 1 goto errors
goto done

:comp_86
echo compiling to TI83-OS
hal86 %filename% %reverse% %description%
tasm.exe -80 -o20 -p60 -q -i %filename%.asm
if errorlevel 1 goto errors
prep86.exe %filename%
if errorlevel 1 goto errors
goto done

:errors
echo There were errors.
goto help

:done
set reverse =
set filename =
set description =
set compile_to =
